<div class="table-responsive">
  <table class="table table-bordered">
    <thead [style.background-color]="bgColor">

      <th *ngFor="let prop of propName">
        {{ (prop.label?  prop.label : prop)}}
        <i *ngIf="prop.sort && pagedItems" class="fa fa-sort" (click)="sortDataByFieldName(prop.key, !sortOrder)"
          (click)="sortOrder = !sortOrder"></i>
        <div *ngIf="prop.search">
          <div [ngSwitch]="prop.controlType">
            <!-- Input Search -->
            <input class="form-control" *ngSwitchCase="'textbox'" (keyup)="filterDataByFieldName($event, prop.key)" />

            <!-- Dropdown Search -->
            <select class="form-control" *ngSwitchCase="'dropdown'" (change)="filterDataByFieldName($event, prop.key)">
              <option *ngFor="let opt of prop.options" [value]="opt.key">
                {{opt.value}}
              </option>
            </select>
          </div>
        </div>
      </th>

      <th class="col-action" *ngIf="showActionField">
        Action
      </th>
    </thead>
    <tbody>
      <ng-container *ngIf="loading">
        Loading....
      </ng-container>

      <ng-container *ngIf="pagedItems">
        <tr *ngFor="let item of pagedItems ">

          <!-- --------- If EDIT MODE is disabled ------------- -->
          <ng-container *ngIf="!itemToEdit || (itemToEdit && itemToEdit._index != item._index)">
            <td *ngFor="let prop of propName">
              {{ item[prop.key] ? item[prop.key] : item[prop]}}
            </td>

            <!-- Action Field Column  -->
            <td class="col-action" *ngIf="showActionField">
              <!-- Preview Edit & Delete Buttons -->
              <span (click)="onEdit(item)">
                <i class="fas fa-pencil-alt mr-2" tooltip="Edit"></i>
              </span>
              <span (click)="onDelete(item)">
                <i class="fas fa-trash-alt mr-2" tooltip="Delete"></i>
              </span>
              <span class="ml-2" *ngIf="isActionInProgress && itemToDelete && itemToDelete._index === item._index">
                <i class="fas fa-spinner fa-spin"></i>
              </span>
            </td>
          </ng-container>

          <!-- ------------------If EDIT MODE is enabled-------------- -->
          <ng-container *ngIf="itemToEdit && itemToEdit._index === item._index">
            <td *ngFor="let column of tableColumns">
              <!-- NOTE: change the component to dynamic form input && question to formControl -->
              <lib-dynamic-form-question [question]="column" [form]="form"></lib-dynamic-form-question>
            </td>

            <!-- Action Field Column  -->
            <td class="col-action" *ngIf="showActionField">
              <!-- Preview Save & Cancel Buttons -->
              <span class="action" (click)="onSave(item)">
                <i class="fa fa-save mr-2" tooltip="Save"></i>
              </span>
              <span (click)="onCancelEdit(item)">
                <i class="fa fa-times" tooltip="Cancel"></i>
              </span>
              <span class="ml-2" *ngIf="isActionInProgress">
                <i class="fas fa-spinner fa-spin"></i>
              </span>
            </td>
          </ng-container>
        </tr>
      </ng-container>

      <!-- No Results -->
      <ng-container *ngIf="!loading && (!pagedItems || pagedItems?.length === 0)">
        <div class="no-results">
          No Results
        </div>
      </ng-container>
    </tbody>
  </table>
</div>

<br />
<div class="pagination-section" *ngIf="!loading && pagedItems?.length > 0">

  <div class="two">Showing {{pagedItems[0]?._index}} to
    {{pagedItems[pagedItems?.length-1]?._index}} of
    {{filteredData?.length > 0 ? filteredData?.length : totalItems}} entries
  </div>

  <div class="pagination" *ngIf="pager.pages && pager.pages.length > 1">
    <a [class.disabled]="currentPage === 1" (click)="previousPage()">&laquo; Previous</a>
    <a [ngClass]="{'active': currentPage === page}" *ngFor="let page of pager.pages" (click)="setPage(page)">{{page}}
    </a>
    <a [class.disabled]="currentPage === pager.totalPages" (click)="nextPage()">Next &raquo;</a>
  </div>
</div>